#!/usr/bin/perl

# (C) Craig Edwards (Brain) 2005
# Simple search/viewing tool for m_sqllog.so tables
# Released under GPL version 2.

my $host = "localhost";

use DBI;
use CGI;
use CGI::Carp qw(fatalsToBrowser);
use POSIX qw(strftime);

my $cgi = new CGI;

print $cgi->header();
print $cgi->start_html( -title => 'InspIRCd m_sqllog search tool', -author => 'InspIRCd');

if (!defined $cgi->param("username"))
{
	print $cgi->h1('Please log in') . "\n";
	print "This utility is designed to assist in searching logs gathered via the InspIRCd m_sqllog.so module.<br><hr><br>";
	print "<form action='inspircd_log.cgi' method='POST'>";
	print "<table>";
	print "<tr><td>MySQL username:</td><td><input name='username' value='inspircd'></td></tr>";
	print "<tr><td>MySQL password:</td><td><input type='password' name='password' value=''></td></tr>";
	print "<tr><td>Database name:</td><td><input name='db' value='inspircd'></td></tr>";
	print "<tr><td colspan='2'><input type='Submit'>";
	print "</table></form>";
}
else
{
	$dbname = $cgi->param("db");
	$username = $cgi->param("username");
	$password = $cgi->param("password");

	$dbh = DBI->connect("DBI:mysql:$dbname", $username, $password) || ThrowWobbly();
	print $cgi->h1('InspIRCd Log Tool');
	
	$sth = $dbh->prepare('SELECT id,actor FROM ircd_log_actors');
	print "<form action='inspircd_log.cgi' method='POST'><center>";
	print "<table width='100%'>";
	print "<tr><td>Event source:</td><td><select name='source'>";
	my $targresults = $dbh->selectall_hashref('SELECT id,actor FROM ircd_log_actors', 'id');
	print "<option value='-1'>&lt;all&gt;</option>";
	foreach my $id (keys %$targresults) {
		print "<option value='$id'>$targresults->{$id}->{actor}</option>";
	}
	print "</select></td>";
	print "<td>Event target:</td><td><select name='target'>";
	print "<option value='-1'>&lt;all&gt;</option>";
	foreach my $id (keys %$targresults) {
		print "<option value='$id'>$targresults->{$id}->{actor}</option>";
	}
	print "</select></td>";
	$sth = $dbh->prepare('SELECT id,actor FROM ircd_log_hosts');
	my $hostresults = $dbh->selectall_hashref('SELECT id,hostname FROM ircd_log_hosts', 'id');
	print "<td>Event hostname:</td><td><select name='hostname'>";
	print "<option value='-1'>&lt;all&gt;</option>";
	foreach my $id (keys %$hostresults) {
		print "<option value='$id'>$hostresults->{$id}->{hostname}</option>";
	}
	print "</select></td>";
	$sth = $dbh->prepare('SELECT category_id,category FROM ircd_log_categories');
	my $catresults = $dbh->selectall_hashref('SELECT category_id,category FROM ircd_log_categories','category_id');
	print "</tr><tr><td>Event category:</td><td><select name='category'>";
	print "<option value='-1'>&lt;all&gt;</option>";
	foreach my $category_id (keys %$catresults) {
		print "<option value='$category_id'>$catresults->{$category_id}->{category}</option>";
	}
	print "</select></td>";
	print "<td>Limit to:</td><td><input name='limit' value='50'></td>";
	print "<td>Order:</td><td><select name='order'><option value='DESC'>Descending</option><option value=''>Ascending</option></select></td>";
	print "</table>";
	print "<input type='hidden' name='username' value='$username'><input type='hidden' name='password' value='$password'><input type='hidden' name='db' value='$dbname'></form>";
	print "<input type='submit'><br><hr><br>";
	print "<table width='90%'>";


	# this query suggested by Jason... well, he suggested i use JOINS and i had to go write this bastard of a query. bleh.
	$sql = "select
                ircd_log.id,
                cat1.category,
                act1.actor as target,
                act2.actor as source,
                host1.hostname as hostname,
                ircd_log.dtime from ircd_log
                left join ircd_log_categories as cat1
                  on ircd_log.category_id=cat1.category_id
                left join ircd_log_actors as act1
                  on ircd_log.nick=act1.id
                left join ircd_log_actors as act2
                  on ircd_log.source=act2.id
                left join ircd_log_hosts as host1
                  on ircd_log.host=host1.id
                where 1=1";

	if (defined $cgi->param("category"))
	{
		my $c = $cgi->param("category");
		if ($c !~ /^(|-)\d+$/) { die "Security violation!"; }
		if ($c != -1)
		{
			$sql = $sql . " AND cat1.category_id = " . $c;
		}
	}
	if (defined $cgi->param("source"))
	{
		my $c = $cgi->param("source");
		if ($c !~ /^(|-)\d+$/) { die "Security violation!"; }
		if ($c != -1)
		{
			$sql = $sql . " AND act2.id = " . $c;
		}
	}
	if (defined $cgi->param("target"))
	{
		my $c = $cgi->param("target");
                if ($c !~ /^(|-)\d+$/) { die "Security violation!"; }
		if ($c != -1)
		{
			$sql = $sql . " AND act1.id = " . $c;
		}
	}
	if (defined $cgi->param("hostname"))
	{
		my $c = $cgi->param("hostname");
                if ($c !~ /^(|-)\d+$/) { die "Security violation!"; }
		if ($c != -1)
		{
			$sql = $sql . " AND host1.id = " . $c;
		}
	}
	my $limit = 50;
	if (defined $cgi->param("limit"))
	{
		my $c = $cgi->param("limit");
                if ($c !~ /^(|-)\d+$/) { die "Security violation!"; }
		$limit = $c;
	}
	my $order = "DESC";
	if (defined $cgi->param("order"))
	{
		my $c = $cgi->param("order");
		if (($c ne "DESC") && ($c ne "")) { die "Security violation!"; }
		$order = $c;
	}

	print "<tr><th align='left'>Time</th><th align='left'>Category</th><th align='left'>Source</th><th align='left'>Target</th><th align='left'>Hostname/IP</th></tr>";

	$sql = $sql . " ORDER BY dtime $order LIMIT 0,$limit";
	$sth = $dbh->prepare($sql); 
	$sth->execute;
	while ( my $searchresults = $sth->fetchrow_hashref) {
		$datetime = $searchresults->{dtime};
		@now_array = gmtime $datetime;
		$now_string = strftime "%a %b %e %H:%M:%S %Y", @now_array;
		print "<tr>";
		print "<td align='left'>$now_string</td>";
		print "<td align='left'>$searchresults->{category}</td>";
		print "<td align='left'>$searchresults->{source}</td>";
		print "<td align='left'>$searchresults->{target}</td>";
		print "<td align='left'>$searchresults->{hostname}</td>";
		print "</tr>";
	}

	print "</table></center>";

	$dbh->disconnect();
}

sub ThrowWobbly()
{
	print $cgi->h1('Error');
	print "Your login credentials or database name are incorrect. Please <a href='inspircd_log.cgi'>go back</a> and try again.";
	exit(0);
}
